/*----------------------------------------------------------------------------*/
/*
    : bitops.c
    : -  
     :  .., .
      : 21.07.08-01:11
*/
/*----------------------------------------------------------------------------*/
#ifndef bitops_c_E
#define bitops_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
#define BITOP_AND	0
#define BITOP_OR	1
#define BITOP_XOR	2

#define BITOP_LSHIFT	3
#define BITOP_RSHIFT	4
/*  */
void stdword_bitops_all(struct fws* ws, int op)
    {
	two_op_pramble();
	//
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		switch(op)
		    {
			case BITOP_AND:{v1.ivar=(v1.ivar) & (v2.ivar);break;}
			case BITOP_OR: {v1.ivar=(v1.ivar) | (v2.ivar);break;}
			case BITOP_XOR:{v1.ivar=(v1.ivar) ^ (v2.ivar);break;}
			case BITOP_LSHIFT:{v1.ivar=((unsigned int)(v1.ivar)) << ((unsigned int)(v2.ivar));break;}
			case BITOP_RSHIFT:{v1.ivar=((unsigned int)(v1.ivar)) >> ((unsigned int)(v2.ivar));break;}
		    }
		to_vstk(ws, &v1);
	    }
	//
	clear_vcode(&v1);
	clear_vcode(&v2);
	//
    }
/*----------------------------------------------------------------------------*/
void stdword_and(struct fws* ws){stdword_bitops_all(ws, BITOP_AND);}
void stdword_or(struct fws* ws){stdword_bitops_all(ws, BITOP_OR);}
void stdword_xor(struct fws* ws){stdword_bitops_all(ws, BITOP_XOR);}
void stdword_lshift(struct fws* ws){stdword_bitops_all(ws, BITOP_LSHIFT);}
void stdword_rshift(struct fws* ws){stdword_bitops_all(ws, BITOP_RSHIFT);}
//
void stdword_not(struct fws* ws)
    {
	one_op_pramble();
	if(v1.type!=WTYPE_CINT){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		v1.ivar = ~(v1.ivar);
		to_vstk(ws, &v1);
	    }
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
#endif /* bitops_c_E */
