/*----------------------------------------------------------------------------*/
/*
    : memory.c
    :    .
		, ,    .
		  , ,  ,   ..
     :  .., .
      : 21.07.08-01:21
*/
/*----------------------------------------------------------------------------*/
#ifndef memory_c_E
#define memory_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
      .
*/
void stdword_getadr(struct fws* ws)
    {
	vcode vmean;
	fword* w;
	if(from_vstk(ws, &vmean)>=0)
	    {	
		if(ISCONST(&vmean)){clear_vcode(&vmean);SETERROR(ws,AFER_NOTVAR);return;}
		w = get_nword(ws,vmean.word);
		vmean.type = WTYPE_CINT;
		switch(w->type)
		    {
			case WTYPE_INT:{vmean.ivar = (int)(&(w->ivar));break;}
			case WTYPE_REAL:{vmean.ivar = (int)(&(w->fvar));break;}
			case WTYPE_ARRAY:
			case WTYPE_STR:{vmean.ivar = (int)(w->svar);break;}
		    }
		to_vstk(ws, &vmean);
	    }
    }
/*----------------------------------------------------------------------------*/
/*
        <> <> setmchar
*/
void stdword_setmchar(struct fws* ws)
    {
	two_op_pramble_z();
	//
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else{*((unsigned char*)(v2.ivar)) = (unsigned char)(v1.ivar);}
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
     32   <> <> setmint
*/
void stdword_setmint(struct fws* ws)
    {
	two_op_pramble_z();
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else{*((int*)(v2.ivar)) = v1.ivar;}
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
     16   <> <> setmshort
*/
void stdword_setmshort(struct fws* ws)
    {
	two_op_pramble_z();
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else{*((unsigned short*)(v2.ivar)) = (unsigned int)(v1.ivar);}
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
        <> <> setmreal
*/
void stdword_setmreal(struct fws* ws)
    {
	two_op_pramble_z();
	if((v1.type != WTYPE_CREAL)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else{*((float*)(v2.ivar)) = v1.fvar;}
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
        <> <> setmstr
*/
void stdword_setmstr(struct fws* ws)
    {
	two_op_pramble_z();
	if((v1.type != WTYPE_CSTR)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else{strcpy((char*)(v2.ivar), v1.svar);}
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
            
*/
void stdword_getmchar(struct fws* ws)
    {
	one_op_pramble();
	unsigned int r = *((unsigned char*)(v1.ivar));
	clear_vcode(&v1);
	v1.type = WTYPE_CINT;
	v1.ivar = r;
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
     32  
*/
void stdword_getmint(struct fws* ws)
    {
	one_op_pramble();
	unsigned int r = *((int*)(v1.ivar));
	clear_vcode(&v1);
	v1.type = WTYPE_CINT;
	v1.ivar = r;
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
     16  
*/
void stdword_getmshort(struct fws* ws)
    {
	one_op_pramble();
	unsigned int r = *((unsigned short*)(v1.ivar));
	clear_vcode(&v1);
	v1.type = WTYPE_CINT;
	v1.ivar = r;
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
       
*/
void stdword_getmreal(struct fws* ws)
    {
	one_op_pramble();
	float r = *((float*)(v1.ivar));
	clear_vcode(&v1);
	v1.type = WTYPE_CREAL;
	v1.fvar = r;
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
       
*/
void stdword_getmstr(struct fws* ws)
    {
	one_op_pramble();
	char* r = ((char*)(v1.ivar));
	clear_vcode(&v1);
	v1.type = WTYPE_CSTR;
	v1.svar = strdup(r);
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
        N       .
      0,      .
*/
void stdword_malloc(struct fws* ws)
    {
	one_op_pramble();
	int t;
	switch(v1.type)
	    {
		case WTYPE_CINT:{t = (int)malloc(v1.ivar);break;}
		default:{SETERROR(ws,AFER_OPUNDTYPES);break;}
	    }
	//
	clear_vcode(&v1);
	v1.type = WTYPE_CINT;
	v1.ivar = t;
	to_vstk(ws, &v1);
    }
/*----------------------------------------------------------------------------*/
/*
     ,    
*/
void stdword_free(struct fws* ws)
    {
	one_op_pramble();
	int t;
	switch(v1.type)
	    {
		case WTYPE_CINT:{free(((void*)(v1.ivar)));break;}
		default:{SETERROR(ws,AFER_OPUNDTYPES);break;}
	    }
	//
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
       
	< > <> realloc
           .
*/
void stdword_realloc(struct fws* ws)
    {
	two_op_pramble_z();
	int newadr=0;
	if((v1.type != WTYPE_CINT)||(v2.type != WTYPE_CINT)){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		newadr = (int)realloc(((void*)(v2.ivar)),v1.ivar);
		cint_to_vstk(ws, newadr);
	    }
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*
        .
	<  > <> aresize
*/
void stdword_aresize(struct fws* ws)
    {
	vcode v1;
	vcode v2;
	int osize;
	fword* w;
	//
	if(from_vstk(ws, &v2)<0){return;}
	if(get_local_copy(ws, &v1)<0){clear_vcode(&v2);return;}
	//    -   
	if((v2.type==WTYPE_ARRAY)&&(v1.type==WTYPE_CINT))
	    {
		//   
		w = get_nword(ws,v2.word);
		//   
		osize = w->size;
		//  
		w->svar = realloc(w->svar,v1.ivar);
		w->size = v1.ivar;
		//     ,     0
		if(v1.ivar > osize){memset(w->svar + osize,0,v1.ivar-osize);}
	    }
	else
	    {
		SETERROR(ws,AFER_INVTYPES);
	    }
	//
	clear_vcode(&v2);
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
#endif /* memory_c_E */
