/*----------------------------------------------------------------------------*/
/*
    : stack.c
    :    - , ,      .. 
     :  .., .
      : 21.07.08-01:31
*/
/*----------------------------------------------------------------------------*/
#ifndef stack_c_E
#define stack_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*     . */
void stdword_dup(struct fws* ws){dup_vstk(ws,0);}
/*----------------------------------------------------------------------------*/
/*     ( -1) . */
void stdword_over(struct fws* ws){dup_vstk(ws,1);}
/*----------------------------------------------------------------------------*/
/*
        .   -    
     0 -    ..
     1 0 nover -   1
     3 1 1 nover -   3
     
     0 nover <=> dup
     1 nover <=> over
 */
void stdword_nover(struct fws* ws)
    {
	vcode v;
	if(get_local_copy(ws,&v)<0){return;}
	if(ftypecasto(&v, WTYPE_CINT)<0){SETERROR(ws,AFER_INVTYPES);goto error;}
	dup_vstk(ws,v.ivar);
	//
	error:
	    clear_vcode(&v);
    }
/*----------------------------------------------------------------------------*/
/*     . */
void stdword_drop(struct fws* ws)
    {
	vcode vmean;
	if(from_vstk(ws, &vmean)>=0){clear_vcode(&vmean);}
    }
/*----------------------------------------------------------------------------*/
/*      . */
void stdword_swap(struct fws* ws)
    {
	vcode* sp1;
	vcode* sp0;
	vcode t;
	// 
	if(!(sp0=top_vstk(ws,0))){return;}
	if(!(sp1=top_vstk(ws,1))){return;}
	//
	memcpy(&t,sp0,sizeof(vcode));
	memcpy(sp0,sp1,sizeof(vcode));
	memcpy(sp1,&t,sizeof(vcode));
	//
    }
/*----------------------------------------------------------------------------*/
/*
          .
    0 nswap -  swap
    1 nswap -    2 
     ..
*/
void stdword_nswap(struct fws* ws)
    {
	vcode* sp1;
	vcode* sp0;
	vcode t;
	//
	vcode v;
	if(get_local_copy(ws,&v)<0){return;}
	if(ftypecasto(&v, WTYPE_CINT)<0){SETERROR(ws,AFER_INVTYPES);clear_vcode(&v);return;}
	// 
	if(!(sp0=top_vstk(ws,0))){return;}
	if(!(sp1=top_vstk(ws,v.ivar+1))){return;}
	//
	memcpy(&t,sp0,sizeof(vcode));
	memcpy(sp0,sp1,sizeof(vcode));
	memcpy(sp1,&t,sizeof(vcode));
	//
    }
/*----------------------------------------------------------------------------*/
#endif /* stack_c_E */
