/*----------------------------------------------------------------------------*/
/*
    : vars.c
    :      - ,   ..
     :  .., .
      : 21.07.08-01:32
*/
/*----------------------------------------------------------------------------*/
#ifndef vars_c_E
#define vars_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
       .
*/
void stdword_var_arr(struct fws* ws, int arr)
    {
	vcode vmean;
	fword* w;
	//     .
	if(get_local_copy(ws,&vmean)<0){return;}
	//   
	if(get_next_word(ws)!=LEXT_UNKNOWN)
	    {
		//     .
		SETERROR(ws,AFER_USEDWORD);
		goto error;
	    }
	//  .
	if(!(w = add_new_word_space(ws))){goto error;}
	w->name = strdup(ws->unknown);
	//
	if(arr)
	    {
		//   -     - 
		w->type = WTYPE_ARRAY;
		//
		switch(GTYPE(&vmean))
		    {
			case WTYPE_CINT:
			    {
				if(vmean.ivar)
				    {
					w->svar = malloc(vmean.ivar);
					memset(w->svar,0,vmean.ivar);
					w->size = vmean.ivar;
				    }
				else
				    { w->svar = NULL;w->size = 0; }
				break;
			    }
			case WTYPE_CARRAY:
			    {
				if(vmean.svar)
				    {
					int l = *((int*)(vmean.svar));
					w->svar = malloc(l);
					w->size = l;
					memcpy(w->svar,(vmean.svar)+sizeof(int),l);
				    }
				else
				    { w->svar = NULL;w->size = 0; }
				break;
			    }
			//
			default:
			    {
				SETERROR(ws,AFER_INVTYPES);goto error;
			    }
		    }	
	    }
	else
	    {
		
		switch(GTYPEC(&vmean))
		    {
			case WTYPE_INT:{w->type = WTYPE_INT;w->ivar = vmean.ivar;w->size = sizeof(int);break;}
			case WTYPE_REAL:{w->type = WTYPE_REAL;w->fvar = vmean.fvar;w->size = sizeof(float);break;}
			case WTYPE_STR:{w->type = WTYPE_STR;w->svar = strdup(vmean.svar);w->size = strlen(vmean.svar)+1;break;}
			default:
			{
			    SETERROR(ws,AFER_INVTYPES);goto error;
			}
		    }
	    }
	//
	error:
	    clear_vcode(&vmean);
	//
    }
/*----------------------------------------------------------------------------*/
/*
     
*/
void stdword_variable(struct fws* ws){stdword_var_arr(ws, 0);}
/*----------------------------------------------------------------------------*/
/*
     
*/
void stdword_array(struct fws* ws){stdword_var_arr(ws, 1);}
/*----------------------------------------------------------------------------*/
/*    -  . */
void stdword_stktovar(struct fws* ws)
    {
	vcode c;
	vcode v;
	fword* w;
	int t;
	//    
	if(from_vstk(ws, &v)<0){return;}
	if(get_local_copy(ws, &c)<0){clear_vcode(&v);return;}
	//  -     !
	if(ISCONST(&v)){SETERROR(ws,AFER_NOTVAR);goto error;return;}
	//
	if((t=ftypecasto(&c, v.type | WORD_CONST))<0){SETERROR(ws,AFER_INVTYPES);goto error;return;}
	//
	w = get_nword(ws,v.word);
	//
	switch(t)
	    {
		case WTYPE_CINT:{w->ivar=c.ivar;break;}
		case WTYPE_CREAL:{w->fvar=c.fvar;break;}
		case WTYPE_CSTR:{free(w->svar);w->svar=strdup(c.svar);break;}
		case WTYPE_CARRAY:
		    {
			free(w->svar);w->svar=NULL;w->size = 0;
			if(c.svar)
			    {
				int l = *((int*)(c.svar));
				w->svar = malloc(l);
				w->size = l;
				memcpy(w->svar,(c.svar)+sizeof(int),l);
			    }
			break;
		    }
	    }
	error:
	    clear_vcode(&c);
	    clear_vcode(&v);
	//
    }
/*----------------------------------------------------------------------------*/
#endif /* vars_c_E */
