/*----------------------------------------------------------------------------*/
/*
    : dict.c
    :   ң. -   ..
     :  .., .
      : 10.03.08-14:25
*/
/*----------------------------------------------------------------------------*/
#ifndef dict_c_E
#define dict_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
int init_dict(fws* ws)
    {
	int i;
	dmsg(" \n");
	//
	for(i=0;i<stddict_size;i++){add_word_copy(ws, stddict+i);}
	dmsg("dict size %i\n",ws->dict_size);
	for(i=0; i<ws->dict_size; i++){dbg_wordinfo(ws->dict +i );}
    }
/*----------------------------------------------------------------------------*/
int done_dict(fws* ws)
    {
	int i;
	for(i=0;i<ws->dict_size;i++)
	    {
		clear_word(ws->dict+i);
	    }
	free(ws->dict);
	ws->dict = NULL;
	ws->dict_size = 0;
	dmsg(" ̣\n");
    }
/*----------------------------------------------------------------------------*/
/*
      (   ,    ).
*/
int clear_word(fword* w)
    {
	if(w)
	    {
		dmsg(" : %s\n",w->name);
		free(w->name);
		w->name=NULL;
		w->size=0;
		switch(GTYPECI(w))
		    {
			case WTYPE_ARRAY:
			case WTYPE_STR:
			    {
				dmsg("\n");
				free(w->svar);
				w->svar=NULL;
				w->size = 0;
				break;
			    }
			case WTYPE_VIRTUAL:
			    {
				struct vcode* v=w->vmcode;
				if(v)
				    {
					while(GETFASTCMD(v)!=FCMD_ENDVM)
					    {
						clear_vcode(v);
						v++;
					    }
					free(w->vmcode);
					w->vmcode = NULL;
				    }
				break;
			    }
		    }
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
       .
        
     NULL (  )
*/
fword* find_word(fws* ws, char* word)
    {
	fword* retval=NULL;
	int i;
	for(i=0;i<ws->dict_size;i++)
	    {
		if(!strcmp(word, ws->dict[i].name))
		    {
			retval = ws->dict + i;
			break;
		    }
	    }
	return(retval);
    }
/*----------------------------------------------------------------------------*/
/*
        .
        
     -1 (  )
*/
int find_nword(fws* ws, char* word)
    {
	int retval=-1;
	int i;
	for(i=0;i<ws->dict_size;i++)
	    {
		if(!strcmp(ws->dict[i].name,word))
		    {
			retval = i;
			break;
		    }
	    }
	return(retval);
    }
/*----------------------------------------------------------------------------*/
/*
         
*/
fword* get_nword(fws* ws, int n)
    {
	if(n>=ws->dict_size){return(NULL);}
	return(ws->dict + n);
    }
/*----------------------------------------------------------------------------*/
/*
       ,    .
        
     NULL (  )
*/
fword* add_new_word_space(fws* ws)
    {
	fword* retval= realloc(ws->dict,(ws->dict_size+1)*sizeof(fword));
	
	if(retval)
	    {
		ws->dict = retval;
		memset(ws->dict + ws->dict_size,0,sizeof(fword));
		retval = ws->dict + ws->dict_size;
		ws->dict_size ++;
	    }
	else
	    {
		SETERROR(ws,AFER_NOMEMORY);
	    }
	return(retval);
    }
/*----------------------------------------------------------------------------*/
/*
           .
*/
int add_word_copy(fws* ws, fword* word)
    {
	fword* cw = add_new_word_space(ws);
	if(cw)
	    {
		memmove(cw,word,sizeof(fword));
		// 
		cw->name = strdup(word->name);
		//
		switch(GTYPECI(word))
		    {
			case WTYPE_STR:
			    {
				cw->svar = strdup(word->svar);
				break;
			    }
			case WTYPE_ARRAY:
			    {
				cw->svar = malloc(word->size);
				memset(cw->svar,0,word->size);
				break;
			    }
		    }
	    }
	else
	    {
		return(-1);
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
    .
*/
#include <autodict.h>
fword	stddict[]=
    {
	#include <autodict.ah>
    };
int stddict_size = sizeof(stddict)/sizeof(fword);
/*----------------------------------------------------------------------------*/
#endif /* dict_c_E */
