/*----------------------------------------------------------------------------*/
/*
    : interp.c
    : 
     :  .., .
      : 10.03.08-18:37
*/
/*----------------------------------------------------------------------------*/
#ifndef interp_c_E
#define interp_c_E
/*----------------------------------------------------------------------------*/
// #undef  DEBUGLEVEL
// #define DEBUGLEVEL 3
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
int do_lexem(fws* ws, int lextype)
    {
	switch (lextype)
	    {
		//    
		case LEXT_CINT:{cint_to_vstk(ws, ws->ivar);break;}
		case LEXT_CREAL:{creal_to_vstk(ws, ws->fvar);break;}
		case LEXT_CSTR:{cstr_to_vstk(ws, ws->svar);break;}
		// 
		case LEXT_WORD:
		    {
			fword* w=get_nword(ws, ws->word);
			dmsg("word var %s %i\n",w->name,w->type);
			switch(GTYPEI(w))
			    {
				// 
				case WTYPE_INT:
				case WTYPE_REAL:
				case WTYPE_STR:
				case WTYPE_ARRAY:
						{var_to_vstk(ws, ws->word);break;}
				// 
				case WTYPE_CINT:{cint_to_vstk(ws, w->ivar);break;}
				case WTYPE_CREAL:{creal_to_vstk(ws, w->fvar);break;}
				case WTYPE_CSTR:{cstr_to_vstk(ws, w->svar);break;}
				
				// 
				case WTYPE_NATIVE:{if(w->ncode){w->ncode(ws);}break;}
				case WTYPE_VIRTUAL:{run_vm_cmd(ws, w->vmcode);break;}
			    }
			break;
		    }
		case LEXT_UNKNOWN:{SETERROR(ws,AFER_UWORD);break;}
	    }
	
	return(0);
    }
/*----------------------------------------------------------------------------*/
int add_array_el(fws* ws, void* elem, int len)
    {
	void* t;
	int l;
	unsigned char*el;
	//   0 - .
	if(!len){return(0);}
	//    -  
	if(!(ws->array))
	    {
		t=realloc(ws->array,sizeof(int));
		//   !
		
		//
		ws->array=t;
		*((int*)(ws->array))=0;
	    }
	//      .
	l = *((int*)(ws->array));
	t=realloc(ws->array,sizeof(int)+len+l);
	//   !
	
	//
	el = ws->array = t;
	memcpy(el+sizeof(int)+l,elem,len);
	*((int*)(ws->array))=l+len;
	//
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
       . { ... }
     -   !!!
*/
void add_array_elem(fws* ws,int lextype)
    {
	dmsg("put to array %i\n",lextype);
	switch (lextype)
	    {
		//   
		case LEXT_CINT:		{add_array_el(ws, &(ws->ivar), ws->arr_int_sz);break;}
		case LEXT_CREAL:	{add_array_el(ws, &(ws->fvar), sizeof(float));break;}
		case LEXT_CSTR:		{add_array_el(ws, ws->svar, strlen(ws->svar)+1);break;}
		// case WTYPE_CARRAY:
		
		// ,    
		
		case LEXT_WORD:
		    {
			fword* w=get_nword(ws, ws->word);
			
			switch(GTYPEI(w))
			    {
				// 
				case WTYPE_CINT:
				case WTYPE_INT:	 {add_array_el(ws, &(w->ivar), ws->arr_int_sz);break;}
				case WTYPE_CREAL:
				case WTYPE_REAL: {add_array_el(ws, &(w->fvar), sizeof(float));break;}
				case WTYPE_CSTR:
				case WTYPE_STR:  {add_array_el(ws, w->svar, strlen(w->svar)+1);break;}
				case WTYPE_ARRAY:
				case WTYPE_CARRAY:{add_array_el(ws, w->svar, w->size);break;}
		
				// 
				case WTYPE_NATIVE:
				    {
					//   }
					if((w->type & WORD_CONSTARRAY)&&(w->ncode)){w->ncode(ws);}
					else{SETERROR(ws,AFER_UWORD);}
					break;
				    }
				case WTYPE_VIRTUAL:{break;}
			    }
			break;
		    }
		case LEXT_UNKNOWN:
		    {
			SETERROR(ws,AFER_UWORD);break;
		    }
	    }
	
    }
/*----------------------------------------------------------------------------*/
#endif /* interp_c_E */
