/*----------------------------------------------------------------------------*/
/*
    : vm.c
    :   
     :  .., .
      : 11.03.08-09:12
*/
/*----------------------------------------------------------------------------*/
#ifndef vm_c_E
#define vm_c_E
/*----------------------------------------------------------------------------*/
#include <string.h>       
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
/*----------------------------------------------------------------------------*/
/*
      .
*/
int run_vm_onecmd(fws* ws, struct vcode* v)
    {
	if(ws->procdeep>=MAX_DEEP){SETERROR(ws,AFER_DEEPOVF);return(-1);}
	//
	ws->procdeep++;
	//
	switch(GTYPE(v))
	    {
		// 
		case WTYPE_CINT:{cint_to_vstk(ws, v->ivar);break;}
		case WTYPE_CREAL:{creal_to_vstk(ws, v->fvar);break;}
		case WTYPE_CSTR:{cstr_to_vstk(ws, v->svar);break;}
		//  
		case (WTYPE_CINT | WORD_ICONST):{cint_to_vstk(ws, ws->dict[v->word].ivar);break;}
		case (WTYPE_CREAL| WORD_ICONST):{creal_to_vstk(ws, ws->dict[v->word].fvar);break;}
		case (WTYPE_CSTR | WORD_ICONST):{cstr_to_vstk(ws, ws->dict[v->word].svar);break;}
		// 
		case WTYPE_INT:
		case WTYPE_REAL:
		case WTYPE_ARRAY:
		case WTYPE_STR:{var_to_vstk(ws, v->word);break;}
		// 
		case WTYPE_NATIVE:
		    {	
			fword* w = get_nword(ws,v->word);
			if(w->ncode){w->ncode(ws);}
			break;
		    }
		case WTYPE_VIRTUAL:
		    {
			fword* w = get_nword(ws,v->word);
			run_vm_cmd(ws, w->vmcode);
			break;
		    }
	    }
	//
	ws->procdeep--;
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
      .
*/
int run_vm_cmd(fws* ws, struct vcode* vmcode)
    {
	struct vcode* v=vmcode;
	//
	ws->rcode = NULL; //  
	if(!v){return(0);}
	//    .
	while(GETFASTCMD(v)!=FCMD_ENDVM)
	    {
		ws->ccmd=v; //  .
		run_vm_onecmd(ws, v);
		if(ws->error){break;}
		if(ws->rcode){v=ws->rcode;ws->rcode=NULL;}else{v++;}
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
#endif /* vm_c_E */
