/*----------------------------------------------------------------------------*/
/*
    : vstk.c
    :    
     :  .., .
      : 10.03.08-14:27
*/
/*----------------------------------------------------------------------------*/
#ifndef vstk_c_E
#define vstk_c_E
/*----------------------------------------------------------------------------*/
//#undef  DEBUGLEVEL
//#define DEBUGLEVEL 3
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
#include <vstk.h>
/*----------------------------------------------------------------------------*/
/*
     vstk
*/
int init_vstk(struct fws* ws)
    {
	ws->vstk = malloc(VSTK_SIZE*sizeof(struct vcode));
	if(ws->vstk){dmsg("vstk \n");ws->vstk_top=-1;}
	else{dmsg("vstk  \n");return(-1);}
	ws->vstk_top=-1;
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
     vstk
*/
int done_vstk(struct fws* ws)
    {
	int i;for(i=0;i<=ws->vstk_top;i++){clear_vcode(ws->vstk + i);}
	//
	free(ws->vstk);
	ws->vstk =NULL;
	dmsg("vstk ̣\n");
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        .
    -1 - 
     0 -ӣ  
*/
int to_vstk(struct fws* ws, struct vcode* vmean)
    {
	if(ws->vstk_top >= (VSTK_SIZE-1))
	    {
		SETERROR(ws,AFER_VSTKOVF);
		return(-1);
	    }
	else
	    {
		ws->vstk_top ++;
		memmove(ws->vstk+ws->vstk_top, vmean, sizeof(struct vcode));
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int cint_to_vstk(struct fws* ws, int mean)
    {
	vcode v={ WTYPE_CINT };
	v.ivar = mean;
	return(to_vstk(ws,&v));
    }
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int creal_to_vstk(struct fws* ws, float mean)
    {
	vcode v= { WTYPE_CREAL };
	v.fvar = mean;
	return(to_vstk(ws,&v));
    }
/*----------------------------------------------------------------------------*/
/*
      -  .
*/
int cstr_to_vstk(struct fws* ws, char* mean)
    {
	vcode v={WTYPE_CSTR };
	v.svar = strdup(mean);
	return(to_vstk(ws,&v));
    }
/*----------------------------------------------------------------------------*/
/*
      .
    n -    
*/
int var_to_vstk(struct fws* ws, int n)
    {
	dmsg("var_to_vstk(%i)\n",n);
	fword* w=get_nword(ws, n);
	vcode v;
	if(!w){return(-1);}
	v.type = w->type;
	v.word = n;
	return(to_vstk(ws,&v));
    }
/*----------------------------------------------------------------------------*/
/*
        
    -1 - 
     0 -ӣ  ,  radr -   
*/
int from_vstk(struct fws* ws, struct vcode* vmean)
    {
	if(ws->vstk_top < 0)
	    {
		SETERROR(ws,AFER_VSTKEMPTY);
		return(-1);
	    }
	else
	    {
		memmove(vmean, ws->vstk+ws->vstk_top, sizeof(struct vcode));
		ws->vstk_top--;
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        ,   disp   (0 - )
      NULL  
*/
struct vcode* top_vstk(struct fws* ws,int disp)
    {
	if((ws->vstk_top < 0)|| (ws->vstk_top < disp))
	    {
		SETERROR(ws,AFER_VSTKEMPTY);
		return(NULL);
	    }
	return(ws->vstk + (ws->vstk_top - disp));
    }
/*----------------------------------------------------------------------------*/
/*
      (  )
*/
void clear_vcode(struct vcode* vmean)
    {
	if(ISCONST(vmean))
	    {
		// ,   .
		switch(GTYPEC(vmean))
		    {
			case WTYPE_ARRAY:
			case WTYPE_STR:
			    {
				free(vmean->svar);
				vmean->svar=NULL;
				break;
			    }
		    }
	    }
    }
/*----------------------------------------------------------------------------*/
/*
         .
      .
        
*/
int get_local_copy(struct fws* ws, struct vcode* vmean)
    {
	struct vcode v;
	//
	if(from_vstk(ws, &v)){return(-1);}
	//
	if(ISCONST(&v)){memcpy(vmean,&v,sizeof(struct vcode));}
	else
	    {
		fword* w = get_nword(ws,v.word);
		switch(v.type)
		    {
			case WTYPE_INT:{vmean->type=WTYPE_CINT;vmean->ivar=w->ivar;break;}
			case WTYPE_REAL:{vmean->type=WTYPE_CREAL;vmean->fvar=w->fvar;break;}
			case WTYPE_STR:{vmean->type=WTYPE_CSTR;vmean->svar=strdup(w->svar);break;}
			case WTYPE_ARRAY:
			default:{SETERROR(ws,AFER_INVTYPES);}
		    }
	    }
	//
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        disp   (0 - )
      .
*/
int dup_vstk(struct fws* ws, int disp)
    {
	struct vcode v;
	struct vcode* top = top_vstk(ws,disp);
	//
	if(!top){return(-1);}
	//
	memcpy(&v,top,sizeof(vcode));
	if(ISCONST(&v))
	    {
		switch(v.type)
		    {
			case WTYPE_CINT:{break;}
			case WTYPE_CREAL:{break;}
			case WTYPE_CSTR:{v.svar = strdup(top->svar);break;}
		    }
	    }
	return(to_vstk(ws,&v));
    }
/*----------------------------------------------------------------------------*/
/*
       ( )   .
       -  -1,  -  
*/
int ftypecast(struct vcode* v1, struct vcode* v2)
    {
	if(v1->type == v2->type){return(v1->type);}
	else if((v1->type == WTYPE_CINT)&&(v2->type == WTYPE_CREAL))
	    {
		v1->type = WTYPE_CREAL;
		v1->fvar = (float)(v1->ivar);
		return(WTYPE_CREAL);
	    }
	else if((v1->type == WTYPE_CREAL)&&(v2->type == WTYPE_CINT))
	    {
		v2->type = WTYPE_CREAL;
		v2->fvar = (float)(v2->ivar);
		return(WTYPE_CREAL);
	    }
	return(-1);
    }
/*----------------------------------------------------------------------------*/
/*
        .
       -  -1,  -  
*/

int ftypecasto(struct vcode* v1, int typ)
    {
	if(v1->type == typ){return(typ);}
	else if((v1->type == WTYPE_CINT)&&(typ == WTYPE_CREAL))
	    {
		v1->type = WTYPE_CREAL;
		v1->fvar = (float)(v1->ivar);
		return(WTYPE_CREAL);
	    }
	else if((v1->type == WTYPE_CREAL)&&(typ == WTYPE_CINT))
	    {
		v1->type = WTYPE_CINT;
		v1->ivar = (int)(v1->fvar);
		return(WTYPE_CINT);
	    }
	return(-1);
    }
/*----------------------------------------------------------------------------*/
#endif /* vstk_c_E */
